var kick = require('../kick')
  , http = require('http')
  , profiler = require('v8-profiler')
  , connect = require('connect')
  , redisClient = require('redis').createClient()
  , RedisStore = require('connect-redis')(connect);

var app = module.exports = kick();

app.use(connect.cookieParser('secret'));

var connectSession = connect.session({ store: new RedisStore, secret: 'keyboard cat' })

var kickSession = function(req, res, next) {
  redisClient.hgetall('sess:foo', function(err, data){
      req.session = data || {}
      next(err)
  })
}

app.get('/set-connect-session', connectSession, function(req, res) {
    if(!req.session) {
      res.writeHead(500)
      res.end()
    } else {
      req.session.username = 'username'
      res.end()
    }
})

app.get('/get-connect-session', connectSession, function(req, res) {
    if(!req.session) {
      res.writeHead(500)
      res.end()
    } else {
      res.end(req.session.username)
    }
})

app.get('/set-kick-session', kickSession, function(req, res) {
    req.session.username = 'foo username'
    res.end()
})

app.get('/get-kick-session', kickSession, function(req, res) {
    res.end('' + req.session)
})

app.get('/', function(req, res){
    res.end()
})

// setInterval(function(){
//   profiler.startProfiling('flow');
//   setTimeout(function(){
//       profiler.stopProfiling('flow');
//   }, 500)
// }, 1000)

var ServerResponse = http.ServerResponse;
var rawEnd = ServerResponse.prototype.end;
console.log(ServerResponse)
console.log(rawEnd)

// ServerResponse.prototype.end = function() {
//   rawEnd.apply(this, [].slice.call(arguments))
//   profiler.stopProfiling('flow');
// }

if(!module.parent) {
  http.createServer(function(req, res){
      // profiler.startProfiling('flow');
      app(req, res);
  }).listen(3000);
}

