var cluster = require('cluster');
var numCPUs = require('os').cpus().length;

if (cluster.isMaster) {
  // Fork workers.
  for (var i = 0; i < numCPUs * 4; i++) {
    cluster.fork();
  }

  cluster.on('death', function(worker) {
      console.log('worker ' + worker.pid + ' died');
  });
} else {

  var http = require('http')
    , redisClient = require('redis').createClient()
    ;

  var app = module.exports = function(req, res) {
    if(req.url == '/redis') {
      redisClient.set('foo', 'bar', function(err, data) {
          res.end('hello world')
      })
    } else {
      res.end('hello world');
    }
  }

  if(!module.parent) {
    http.createServer(app).listen(3000);
  }

}


